//------------------------------------------------------------------
#property copyright "www,forex-station.com"
#property link      "www,forex-station.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrBlue
#property indicator_color2  clrRed
#property indicator_width1  4
#property indicator_width2  4
#property indicator_minimum 0
#property indicator_maximum 1
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;    // Time frame
extern int                CCIPeriod       = 50;                // CCI period
extern ENUM_APPLIED_PRICE CCIPrice        = PRICE_TYPICAL;     // Price
input bool                alertsOn        = false;             // Alerts on true/false?
input bool                alertsOnCurrent = true;              // Alerts on open bar true/false?
input bool                alertsMessage   = true;              // Alerts message true/false?
input bool                alertsSound     = false;             // Alerts sound true/false?
input bool                alertsNotify    = false;             // Alerts push notification true/false?
input bool                alertsEmail     = false;             // Alerts email true/false?
input string              soundFile       = "alert2.wav";      // Sound file

double cci[],cciU[],cciD[],prices[],trend[],count[];
string IndicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,CCIPeriod,CCIPrice,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,_buff,_ind)

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int OnInit()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,cciU); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,cciD); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,cci);
      SetIndexBuffer(3,prices);
      SetIndexBuffer(4,trend);
      SetIndexBuffer(5,count);
         IndicatorFileName = WindowExpertName();
         TimeFrame         = fmax(TimeFrame,_Period);   
   IndicatorSetString(INDICATOR_SHORTNAME,timeFrameToString(TimeFrame)+" CCI ("+(string)CCIPeriod+")");
return(INIT_SUCCEEDED);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int  OnCalculate(const int rates_total,const int prev_calculated,const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int i=rates_total-prev_calculated+1; if (i>=rates_total) i=rates_total-1; count[0]=i;
      if (TimeFrame != Period())
      {
         i = (int)fmax(i,fmin(rates_total-1,_mtfCall(5,0)*TimeFrame/_Period));
         for (; i>=0 && !_StopFlag; i--)
         {
            int y = iBarShift(NULL,TimeFrame,time[i]);
               cciU[i] = _mtfCall(0,y);
               cciD[i] = _mtfCall(1,y);
         }
    return(rates_total);
    }            

   //
   //
   //

   for (; i>=0 && !_StopFlag; i--)
   {
      prices[i] = iMA(NULL,0,1,0,MODE_SMA,CCIPrice,i);
      double avg = 0; for(int k=0; k<CCIPeriod && (i+k)<rates_total; k++) avg +=      prices[i+k];      avg /= (CCIPeriod);
      double dev = 0; for(int k=0; k<CCIPeriod && (i+k)<rates_total; k++) dev += fabs(prices[i+k]-avg); dev /= (CCIPeriod);
            cci[i]   = (dev!=0) ? (prices[i]-avg)/(0.015*dev) : 0;
            trend[i] = (cci[i]>0) ? 1 : (cci[i]<0) ? -1 : (i<rates_total-1) ? trend[i+1] : 0;
            cciD[i]  = (trend[i] == -1) ? 1 : EMPTY_VALUE;
            cciU[i]  = (trend[i] ==  1) ? 1 : EMPTY_VALUE;
   }
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(" crossing zero up");
         if (trend[whichBar] ==-1) doAlert(" crossing zero down");       
      }         
    }          
return(rates_total);
}

//------------------------------------------------------------------
// Alert function
//------------------------------------------------------------------

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" cci trend "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" cci trend ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}